#!/usr/bin/env python

# Inspire by Conbagui tutorial found here: https://gimpnexux.blogspot.com/search?q=tecno

# It Creates a plastic like with neon center text
# author: Pocholo
# date: 8/8/2020

# Comments directed to http://gimpchat.com

# Installation:
# This script should be placed in the user plugins folder



# Copyright (C)

#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by   
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY# without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <https://www.gnu.org/licenses/>. 

from gimpfu import *

def pm_lurid_text_logo(img, draw, customtext, font, glowLayer, glowColor, setglow, hue, lightness, saturation):
	
	#Set Undo Start
	pdb.gimp_image_undo_group_start(img)
	
	#Initiates the temporary state
	pdb.gimp_context_push()
	
	#Variables
	width = img.width
	height = img.height
	 
	#Remove the new image
	pdb.gimp_image_remove_layer(img, draw)
				
	#Create the text
	pdb.gimp_context_set_foreground((0, 0, 0))
	textLayer = pdb.gimp_text_fontname(img, None, 0, 0, customtext, 70, 
										TRUE, 400, PIXELS, font)
	pdb.gimp_text_layer_set_letter_spacing(textLayer, 50)
	pdb.gimp_text_layer_set_justification(textLayer, 2)		
	
	img.resize(textLayer.width, textLayer.height, 0, 0)
	
	
	
	
	#Create background
	backLayer = pdb.gimp_layer_new(img, img.width, img.height, RGB_IMAGE, "Background", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, backLayer, 1)
	pdb.gimp_context_set_background('#052726')
	pdb.gimp_edit_fill(backLayer, FILL_BACKGROUND)
		
	#Create a selection on the text and save to path
	pdb.gimp_image_select_item(img, 2, textLayer)
	pdb.plug_in_antialias(img, textLayer)
	pdb.plug_in_sel2path(img, textLayer)
	pdb.gimp_selection_none(img)
	
	#Create a text copy
	non_empty = pdb.gimp_edit_copy(textLayer)
	textCopy = pdb.gimp_layer_new(img, img.width, img.height, RGB, "tecno copy", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, textCopy, 0)
	pdb.gimp_layer_add_alpha(textCopy)
	pdb.gimp_drawable_fill(textCopy, FILL_TRANSPARENT)
	floating_sel = pdb.gimp_edit_paste(textCopy, FALSE)
	pdb.gimp_floating_sel_anchor(floating_sel)
	pdb.gimp_item_set_visible(textCopy, FALSE)
	
	
	
	
	#Add a new layer 55 pix over the background 
	pdb.gimp_image_set_active_layer(img, backLayer)
	layer55pix = pdb.gimp_layer_new(img, img.width, img.height, RGB, "55 pix", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, layer55pix, -1)
	pdb.gimp_layer_add_alpha(layer55pix)
	pdb.gimp_drawable_fill(layer55pix, FILL_TRANSPARENT)
	
	#Set the brush and stroke path 55
	pdb.gimp_context_set_foreground((49, 49, 49))
	pdb.gimp_context_set_brush("2. Hardness 100")
	pdb.gimp_context_set_brush_size(55)
	pdb.gimp_context_set_paint_method("gimp-paintbrush")
	pdb.gimp_context_set_stroke_method(STROKE_PAINT_METHOD)
	vectors55 = pdb.gimp_image_get_active_vectors(img)
	pdb.gimp_edit_stroke_vectors(layer55pix, vectors55)
	
	#Add a new layer over the 55 
	pdb.gimp_image_set_active_layer(img, backLayer)
	layer35pix = pdb.gimp_layer_new(img, img.width, img.height, RGB, "35 pix", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, layer35pix, 2)
	pdb.gimp_layer_add_alpha(layer35pix)
	pdb.gimp_drawable_fill(layer35pix, FILL_TRANSPARENT)
	
	#Set the brush and stroke path 35
	pdb.gimp_context_set_foreground((65, 65, 65))
	pdb.gimp_context_set_brush("2. Hardness 100")
	pdb.gimp_context_set_brush_size(35)
	pdb.gimp_context_set_paint_method("gimp-paintbrush")
	pdb.gimp_context_set_stroke_method(STROKE_PAINT_METHOD)
	pdb.gimp_edit_stroke_vectors(layer35pix, vectors55)
	
	#Create a 55 copy and clean
	pdb.gimp_image_set_active_layer(img, layer55pix)
	non_empty = pdb.gimp_edit_copy(layer55pix)
	copy55Layer = pdb.gimp_layer_new(img, img.width, img.height, RGB, "55 copy", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, copy55Layer, -2)
	pdb.gimp_layer_add_alpha(copy55Layer)
	pdb.gimp_drawable_fill(copy55Layer, FILL_TRANSPARENT)
	floating_sel = pdb.gimp_edit_paste(copy55Layer, FALSE)
	pdb.gimp_floating_sel_anchor(floating_sel)
	pdb.gimp_image_set_active_layer(img, layer35pix)
	pdb.gimp_image_select_item(img, 2, layer35pix)
	pdb.gimp_edit_clear(copy55Layer)
	pdb.gimp_selection_none(img)
	
	#Create two 35 pix copies and place them on top of the group
	non_empty = pdb.gimp_edit_copy(layer35pix)
	copy35Layer = pdb.gimp_layer_new(img, img.width, img.height, RGB, "35 copy", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, copy35Layer, 0)
	pdb.gimp_layer_add_alpha(copy35Layer)
	pdb.gimp_drawable_fill(copy35Layer, FILL_TRANSPARENT)
	floating_sel = pdb.gimp_edit_paste(copy35Layer, FALSE)
	pdb.gimp_floating_sel_anchor(floating_sel)
	pdb.gimp_item_set_visible(copy35Layer, FALSE)
	non_empty = pdb.gimp_edit_copy(copy35Layer)
	copy1_35Layer = pdb.gimp_layer_new(img, img.width, img.height, RGB, "35 copy", 100, LAYER_MODE_NORMAL)
	pdb.gimp_image_add_layer(img, copy1_35Layer, 0)
	pdb.gimp_layer_add_alpha(copy1_35Layer)
	pdb.gimp_drawable_fill(copy1_35Layer, FILL_TRANSPARENT)
	floating_sel = pdb.gimp_edit_paste(copy1_35Layer, FALSE)
	pdb.gimp_floating_sel_anchor(floating_sel)
	pdb.gimp_item_set_visible(copy1_35Layer, FALSE)
	
		
	#create some effect on 55 copy 
	#Bevel and Emboss
	pdb.python_layerfx_bevel_emboss(img, copy55Layer, 
													 1,   #style inner bevel
													65,   #depth 
													 0,   #direction 
													10,   #size 
													 5,   #soften
												   108,   #angle 
													30,   #altitude 
													 0,   #gloss_contour 
											   "White",   #highlight_color 
													10,   #highlight_mode-lighten only
													75,   #highlight_opacity
											   "Black",   #shadow_color 
													 3,   #shadow_mode-multiply
													75,   #shadow_opacity 
													 6,   #surface_contour 
												 FALSE,   #use_texture 
										   "Dried mud",   #pattern 
												   100,   #scale 
												   100,   #tex_depth 
												  TRUE,   #invert 
												  TRUE)   #merge			 												 	
	
	#Layer35 inner shadow
	pdb.gimp_image_set_active_layer(img, layer35pix)
	pdb.python_layerfx_inner_shadow(img, layer35pix, 
								       "Black",   #color
									        55,   #opacity
										     0,   #contou
										     0,   #noise
										     3,   #mode-multiply
										     1,   #source
										     0,   #choke 
									         8,   #size 
										   120,   #offset_angle 
										    12,   #offset_distance 
									      TRUE)  #merge
					
	#Text layer inner shadow
	pdb.gimp_image_set_active_layer(img, textLayer)
	pdb.python_layerfx_inner_shadow(img, textLayer, 
								       "Black",   #color
									        75,   #opacity
										     0,   #contou
										     0,   #noise
										     3,   #mode-multiply
										     1,   #source
										    60,   #choke 
									        30,   #size 
										   120,   #offset_angle 
										     0,   #offset_distance 
									      FALSE)  #merge	
		
	#Bevel and Emboss
	pdb.python_layerfx_bevel_emboss(img, textLayer, 
													 3,   #style inner bevel
													65,   #depth 
													 1,   #direction 
													12,   #size 
													 7,   #soften
												   120,   #angle 
													30,   #altitude 
													 3,   #gloss_contour 
											   "White",   #highlight_color 
													 4,   #highlight_mode-screen
												   100,   #highlight_opacity
											   "Black",   #shadow_color 
													 3,   #shadow_mode-multiply
													75,   #shadow_opacity 
													 6,   #surface_contour 
												 FALSE,   #use_texture 
										   "Dried mud",   #pattern 
												   100,   #scale 
												   100,   #tex_depth 
												  TRUE,   #invert 
												  FALSE)   #merge
		
	#Inner glow
	pdb.python_layerfx_inner_glow(img, textLayer, 
						       (0, 255, 255),   #color
								         100,   #opacity
								           0,   #contou
								           0,   #noise
								          18,   #mode-hard light 
							               0,   #source
										  24,   #choke 
								          20,   #size 
							           FALSE)   #merge		
					
	#Inner glow
	pdb.gimp_image_set_active_layer(img, textCopy)
	pdb.python_layerfx_inner_glow(img, textCopy, 
						       (0, 255, 255),   #color
								         100,   #opacity
								           0,   #contou
								           0,   #noise
								          19,   #mode-soft light 
							               0,   #source
										   0,   #choke 
								          30,   #size 
							           FALSE)   #merge

	
	#Bevel and Emboss
	pdb.gimp_image_set_active_layer(img, copy35Layer)
	pdb.python_layerfx_bevel_emboss(img, copy35Layer, 
													 1,   #style inner bevel
													65,   #depth 
													 0,   #direction 
													21,   #size 
													 3,   #soften
												   100,   #angle 
													70,   #altitude 
													 0,   #gloss_contour 
								       (205, 205, 205),   #highlight_color 
													 4,   #highlight_mode-screen
												    75,   #highlight_opacity
											   "Black",   #shadow_color 
													 3,   #shadow_mode-multiply
													75,   #shadow_opacity 
													 0,   #surface_contour 
												 FALSE,   #use_texture 
										   "Dried mud",   #pattern 
												   100,   #scale 
												   100,   #tex_depth 
												  TRUE,   #invert 
												  FALSE)   #merge

	#Bevel and Emboss
	pdb.gimp_image_set_active_layer(img, copy1_35Layer)
	pdb.python_layerfx_bevel_emboss(img, copy1_35Layer, 
													 1,   #style inner bevel
													65,   #depth 
													 0,   #direction 
													21,   #size 
													 3,   #soften
												   120,   #angle 
													48,   #altitude 
													 0,   #gloss_contour 
								               "White",   #highlight_color 
													18,   #highlight_mode-hard light
												    75,   #highlight_opacity
											   "Black",   #shadow_color 
													 3,   #shadow_mode-multiply
													75,   #shadow_opacity 
													 0,   #surface_contour 
												 FALSE,   #use_texture 
										   "Dried mud",   #pattern 
												   100,   #scale 
												   100,   #tex_depth 
												  TRUE,   #invert 
												  FALSE)   #merge														

	#Create the layer for the glow if wanted
	if glowLayer == True:
		pdb.gimp_image_set_active_layer(img, layer55pix)
		pdb.gimp_image_select_item(img, 2, layer55pix)
		glowLayer = pdb.gimp_layer_new(img, img.width, img.height, RGB, "Glow", 100, LAYER_MODE_NORMAL)
		pdb.gimp_image_add_layer(img, glowLayer, 16)
		pdb.gimp_layer_add_alpha(glowLayer)
		pdb.gimp_drawable_fill(glowLayer, FILL_TRANSPARENT)
		pdb.gimp_context_set_foreground(glowColor)
		pdb.gimp_edit_fill(glowLayer, FILL_FOREGROUND)
		pdb.gimp_selection_none(img)
		pdb.plug_in_gauss(img, glowLayer, setglow, setglow, 1)	
		
	
	if glowLayer == False:
		pdb.gimp_selection_none(img)
	
	#Remove invisible layers
	pdb.gimp_image_remove_layer(img, textCopy)
	pdb.gimp_image_remove_layer(img, copy35Layer)
	pdb.gimp_image_remove_layer(img, copy1_35Layer)
	
	#Merge visible layer into one
	pdb.gimp_item_set_visible(backLayer, FALSE)
	mergelayer = pdb.gimp_image_merge_visible_layers(img, CLIP_TO_IMAGE)
	pdb.gimp_item_set_name(mergelayer, "Lurid effect")
	pdb.gimp_item_set_visible(backLayer, TRUE)
	
	#Recolor
	pdb.gimp_drawable_hue_saturation(mergelayer, 0, hue, lightness, saturation, 0)
	
	
	
	#Set Undo End
	pdb.gimp_image_undo_group_end(img)
	
	#Resets the previous user defaults
	pdb.gimp_context_pop()
			
register(
	"pm_lurid_text_logo",
	"Creates a lurid text logo",
	"Creates a lurid text logo",
	"Pocholo",
	"Pocholo",
	"2020",
	"Lurid text logo",
	"RGB*",
[
	(PF_IMAGE, "img", "Input image", None),
	(PF_DRAWABLE, "draw", "Input drawable", None),
	(PF_STRING, "customtext", "Text string", 'tecno'),
    (PF_FONT, "font", "Font face", "Comfortaa Bold"),
	(PF_TOGGLE, "glow", "Glow?", True),
	(PF_COLOR, "glowColor", "Glow color", (0, 255, 255)),
	(PF_SLIDER, "setglow", "Set glow", 30, (30, 60, 1)),
	(PF_SLIDER, "hue", "Hue lever", 0, (-180, 180, 1)),
	(PF_SLIDER, "lightness", "Lightness lever", 0, (-100, 100, 1)),
	(PF_SLIDER, "saturation", "Saturation lever", 0, (-100, 100, 1)),
],
[],
pm_lurid_text_logo, menu="<Image>/Pocholo-scripts/Lurid text logo"),
main()		